// 10 bit encoder version of Trim Box code
unsigned char ReadBuffer[1] absolute 0x500;
unsigned char WriteBuffer[7] absolute 0x540;
unsigned short int buttons;
unsigned long int scaleFactor = 1023;
unsigned long int temp1;
unsigned long int temp2;
unsigned long int temp3;
signed int count1,count2,count3;
unsigned char sensorA1,sensorA2,oldsensorA1,oldsensorA2;
signed int directionA;
unsigned char flag1,flag2,flag3;
unsigned int QUAD1A, QUAD1A_OLD, QUAD1A_NEW, QUAD1B, QUAD1B_OLD, QUAD1B_NEW;
unsigned int QUAD2A, QUAD2A_OLD, QUAD2A_NEW, QUAD2B, QUAD2B_OLD, QUAD2B_NEW;
unsigned int QUAD3A, QUAD3A_OLD, QUAD3A_NEW, QUAD3B, QUAD3B_OLD, QUAD3B_NEW;

void interrupt(void){
 
 if(INTCON3.INT1IF==1)
                {
         directionA = 0; // Default to zero upon an error/no movement
         sensorA1 = PORTB.RB0;
         sensorA2 = PORTB.RB1;
  if (!((oldsensorA1 ^ sensorA1) & !(oldsensorA2 ^ sensorA2)) )
  {                        // If this was fwd/back
        directionA = -1;    // Default to reverse
        if (oldsensorA1 ^ sensorA2) directionA = 1; //Set direction to 1 if fwd
  }

  count1 += directionA;
  oldsensorA1 = sensorA1;
  oldsensorA2 = sensorA2;

  INTCON3.INT1IF = 0;     //Clear INT1 interrupt flag
  
                }
 else

 if(INTCON.RBIF==1)
                {
                          QUAD2A = PORTB.RB4;
                          QUAD2B = PORTB.RB5;

                          QUAD2A_NEW = QUAD2A;
                          QUAD2B_NEW = QUAD2B;

                          if (QUAD2A_NEW + QUAD2B_NEW == 2) flag2 = 1;

                          if ((flag2 == 1) & (QUAD2A_NEW + QUAD2B_NEW == 1))
                          {
                          QUAD2A_OLD = QUAD2A_NEW;
                          QUAD2B_OLD = QUAD2B_NEW;
                          flag2 = 2;
                          }
                          if ((flag2 == 2) & (QUAD2A_NEW + QUAD2B_NEW == 0))
                          {
                          if (QUAD2B_OLD == 1) {count2++; flag2 = 3;}
                          if (QUAD2A_OLD == 1) {count2--; flag2 = 3;}
                          }


                          QUAD3A = PORTB.RB6;
                          QUAD3B = PORTB.RB7;

                          QUAD3A_NEW = QUAD3A;
                          QUAD3B_NEW = QUAD3B;

                          if (QUAD3A_NEW + QUAD3B_NEW == 2) flag3 = 1;

                          if ((flag3 == 1) & (QUAD3A_NEW + QUAD3B_NEW == 1))
                          {
                          QUAD3A_OLD = QUAD3A_NEW;
                          QUAD3B_OLD = QUAD3B_NEW;
                          flag3 = 2;
                          }
                          if ((flag3 == 2) & (QUAD3A_NEW + QUAD3B_NEW == 0))
                          {
                          if (QUAD3B_OLD == 1) {count3++; flag3 = 3;}
                          if (QUAD3A_OLD == 1) {count3--; flag3 = 3;}
                          }


                        INTCON.RBIF=0; //Clear port B interrupts flag
                }
else

USB_Interrupt_Proc();
                
                
                
}//end ISR

void main() {
    
    PORTB = 0x00;
    TRISB = 0xFF;    // PORTB is input
    PORTC = 0x00;
    TRISC = 0xC4;    // switches are RC6, RC7, RC2
   
    count1 = 0x0000;
    count2 = 0x0000;
    count3 = 0x0000;
    // set up interrupt priorities:
    INTCON.GIEH = 1;                // enable Global high priority interrupts
    INTCON.GIEL = 1;                // enable Global low priority interrupts
    INTCON.PEIE = 1;                // enable peripheral interrupts
    INTCON2.RBIP = 0;               // RBIP interrupt = low priority
    INTCON3.INT1P = 0;              // INT1 interrupt = low priority
    RCON.IPEN = 1;                  // enable interrupt priorities
    // initialise interrupts:
    INTCON3.INT1IF = 0;              // Clear INT1 flag prior to enable
    INTCON2.INTEDG1 = 1;            // interrupt INT1 on rising edge
    INTCON3.INT1IE = 1;              // enable INT1 interrupt
    INTCON.RBIF = 0;                // Clear RB interrupt flag prior to enable
    INTCON.RBIE = 1;                // enable RB change interrupts


    //enable USB
    HID_Enable(&ReadBuffer, &WriteBuffer);
    //allow for HID set up time
    delay_ms(1000);
    // ensure USB is set to high priority
    IPR2.USBIP = 1;                 // USB interrupt = high priority
    

do {

       if (count1 > 1023) count1 = 1023;
         else
       if (count1 < 0) count1 = 0; // SET MAX COUNT AND MIN  for count1
       temp1 = count1  - 511;
       WriteBuffer[0] = temp1 & 0x00FF;      // X axis
       WriteBuffer[1] = (temp1 & 0xFF00) >>8;

       if (count2 > 1023) count2 = 1023;
         else
       if (count2 < 0) count2 = 0; // SET MAX COUNT AND MIN  for count2
       temp2 = count2 - 511;
       WriteBuffer[2] = temp2 & 0x00FF;      // Y axis
       WriteBuffer[3] = (temp2 & 0xFF00) >>8;

       if (count3 > 1023) count3 = 1023;
         else
      if (count3 < 0) count3 = 0; // SET MAX COUNT AND MIN  for count3
       temp3 = count3 - 511;
       WriteBuffer[4] = temp3 & 0x00FF;      // Z axis
       WriteBuffer[5] = (temp3 & 0xFF00) >>8;

       buttons = (((PORTC & 0xC0)>>6)|(PORTC & 0x04));
        WriteBuffer[6] = (buttons & 0x07);


        //Write the buffers to USB
        while(!HID_Write(&WriteBuffer, 7));


   }while(1);
 }